/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dbfastclockwebserver;

/**
 *
 * @author Daniels laptop
 */
public abstract class Clock
{
	protected MySignal mySignal;
	
	protected Clock(MySignal mySignal)
	{
		this.mySignal = mySignal;
	}
	
	
	public abstract String getName();
	
	
	// iHour: Time in hours
	// iMin: Time in minutes
	// iSec: Time in seconds
	// dSpeed: Speed
	// iVerticalSize: Vertical size of screen in percent
	protected abstract String getClockHTMLPage(int iHour, int iMin, int iSec, double dSpeed, int iVerticalSize);
	
	
	public String getHTMLPage(int iHour, int iMin, int iSec, double dSpeed, String sMessage)
	{
		int iVerticalSize = 100;
		String page = "";
		
		page += "HTTP/1.0 200 OK\r\n";
		page += "Connection: close\r\n";
		page += "Server: DBFastClockWebServer\r\n";
		page += "Content-Type: text/html; charset=utf-8\r\n";
		page += "\r\n";
		
		if (useHTML5())
			page += "<!DOCTYPE html>\n";
		
		page += "<html>\n";
		page += "<head>\n";
		page += "<title>DBFastClockWebClient</title>\n";
		page += "<script type=\"text/JavaScript\">\n";
		page += "<!--\n";
		page += "function timedRefresh(timeoutPeriod) {\n";
		page += "	setTimeout(\"location.reload(true);\",timeoutPeriod);\n";
		page += "}\n";
		page += "//   -->\n";
		page += "</script>\n";
		page += "<style>\n";
//		page += "div {font-family:\"Arial\", Times, serif;}";
//		page += "div {font-family:\"Verdana\", Times, serif;}";
		page += "div {font-family:\"Times New Roman\", Times, serif;}";
		page += "a:link {text-decoration:none; color:black;}";
		page += "a:visited {text-decoration:none; color:black;}";
		page += "a:hover {text-decoration:none; color:black;}";
		page += "a:active {text-decoration:none; color:black;}";
		page += "</style>";
		page += "</head>\n";
		page += "\n";
		
		if (isMenu())
			page += "<body style=\"overflow:hidden;\">\n";
		else
			page += "<body onload=\"timedRefresh(2000);\" style=\"overflow:hidden;\">\n";
		
		if ( (sMessage != null) && (! sMessage.isEmpty()) )
			iVerticalSize = 80;
		
		
//		page += "<a href=\"/\">";
		if (! isMenu())
			page += "<a onclick=\"location.href='/"+mySignal.getMenuClock().getName()+"';\">";
		
		page += getClockHTMLPage(iHour, iMin, iSec, dSpeed, iVerticalSize);
		
		if (! isMenu())
			page += "</a>";
		
		
		
		
		if ( (sMessage != null) && (! sMessage.isEmpty()) )
		{
//			page += "<div id=\"message_container\" style=\"width: 100%; height: " + (100-iVerticalSize) + "%; border: 0px; white-space:nowrap;\">\n";
			page += "<div id=\"message_container\" style=\"width: 100px; height: 100px; border: 0px; white-space:nowrap;\">\n";
			page += "<script language=\"JavaScript\">\n";
			page += "<!--\n";
			page += "var message_container = document.getElementById (\"message_container\");\n";
			page += "message_container.style.width = (window.innerWidth*0.95)+'px';\n";
			page += "message_container.style.height = (window.innerHeight*0.95*"+(100-iVerticalSize)+"/100)+'px';\n";
			page += "var textMittW = window.innerWidth;\n";
			page += "var textMittH = window.innerHeight*"+(100-iVerticalSize)+"/100;\n";
//			page += "var textMittW = message_container.offsetWidth;\n";
//			page += "var textMittH = message_container.offsetHeight*"+(100-iVerticalSize)+"/100;\n";
			page += "var textFactorW = 2.5;\n";
			page += "var textFactorH = 1.2;\n";
			page += "var calculatedfontSize;\n";
//			page += "if( (textMittH/textFactorH) < (textMittW/textFactorW) ){\n";
			page += "calculatedfontSize=textMittH/textFactorH;\n";
//			page += "}\n";
//			page += "else{\n";
//			page += "calculatedfontSize=textMittW/textFactorW;\n";
//			page += "}\n";
			page += "var currentTime=\"" + sMessage + "\";\n";
			page += "var theTime = '<div style=\"font-size:'+calculatedfontSize+'px\">'+currentTime+'</div>';\n";
			page += "document.write(theTime);\n";
			page += "// -->\n";
			page += "</script>\n";
			page += "</div>\n";
		}
		
		
		page += "</body>\n";
		page += "</html>\n";
		
		return page;
	}
	
	
	protected boolean useHTML5()
	{
		return false;
	}
	
	
	protected boolean isMenu()
	{
		return false;
	}
	
}
