/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dbfastclockwebserver;

import java.util.List;

/**
 *
 * @author Daniels laptop
 */
public class ClockMenu extends Clock
{
	private static ClockMenu ClockMenu = null;
	
	
	private ClockMenu(MySignal mySignal)		// Don't allow anyone except the class itself to create an instance
	{
		super(mySignal);
	};
	
	
	public static ClockMenu GetClock(MySignal mySignal)
	{
		if (ClockMenu == null)
			ClockMenu = new ClockMenu(mySignal);
		
		return ClockMenu;
	}
	
	
	@Override
	public String getName()
	{
		return "ClockMenu";
	}

	@Override
	protected String getClockHTMLPage(int iHour, int iMin, int iSec, double dSpeed, int iVerticalSize)
	{
		String page = "";
		String menu = "";
		int numClockTypes = 0;
		
		for (Clock clock : mySignal.getClockList())
		{
			if (clock != this)
			{
				menu += "<a href=\""+clock.getName()+"\">"+mySignal.getLocalizedName("clocktype_", clock.getName())+"</a><br>";
				numClockTypes++;
			}
		}
		
		if (numClockTypes == 0)
			numClockTypes = 1;		// We get division by zero if numClockTypes is zero
		
		page += "<div id=\"textcontainer\" style=\"width: 100%; height: "+iVerticalSize+"%; border: 0px; font-family:'Times New Roman', Times, serif;\">\n";
		page += "<script language=\"JavaScript\">\n";
		page += "<!--\n";
		page += "var textcontainer = document.getElementById (\"textcontainer\");\n";
		page += "var mittH = textcontainer.offsetHeight;\n";
		page += "var mittW = textcontainer.offsetWidth;\n";
		page += "var factorH = 1.2*"+numClockTypes+";\n";
		page += "var factorW = 9;\n";
//		page += "var factorW = 2.5;\n";
		page += "var calculatedfontSize;\n";
		page += "if( (mittH/factorH) < (mittW/factorW) ){\n";
		page += "calculatedfontSize=mittH/factorH;\n";
		page += "}\n";
		page += "else{\n";
		page += "calculatedfontSize=mittW/factorW;\n";
		page += "}\n";
		page += "var currentTime=\""+"Test"+"\";\n";
		page += "var theTime = '<div style=\"font-size:'+calculatedfontSize+'px\">"+menu+"</div>';\n";
		page += "document.write(theTime);\n";
		page += "window.onresize = function(event) { location.reload(true); };\n";
		page += "// -->\n";
		page += "</script>\n";
		page += "</div>\n";
		
		return page;
	}
	
	
	@Override
	protected boolean isMenu()
	{
		return true;
	}
	
}
