/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dbfastclockwebserver;

/**
 *
 * @author Daniels laptop
 */
public class HTMLClock extends Clock
{
	private static HTMLClock htmlClock = null;
	
	
	private HTMLClock(MySignal mySignal)		// Don't allow anyone except the class itself to create an instance
	{
		super(mySignal);
	};
	
	
	public static HTMLClock GetClock(MySignal mySignal)
	{
		if (htmlClock == null)
			htmlClock = new HTMLClock(mySignal);
		
		return htmlClock;
	}
	
	
	@Override
	public String getName()
	{
		return "HTMLClock";
	}
	
	
	// Binary coding of 7-segment-display
	//   1        a
	// 2   3    b   c
	//   4        d
	// 5   6    e   f
	//   7        g
	static int iSevenSegmentDisplay[] = {119,36,93,109,46,107,123,39,127,111};
	static int iCount = 0;
	
	
	@Override
	protected String getClockHTMLPage(int iHour, int iMin, int iSec, double dSpeed, int iVerticalSize)
	{
		String page = "";
		
		String fgColor = "green";
//		String fgColor = "blue";
		String bgColor = "white";
		
		int iHour_FirstDigit = iHour / 10;
		int iHour_SecondDigit = iHour % 10;
		int iMin_FirstDigit = iMin / 10;
		int iMin_SecondDigit = iMin % 10;
		
//		System.out.println("Clock: "+iHour_FirstDigit+" "+iHour_SecondDigit+" : "+iMin_FirstDigit+" "+iMin_SecondDigit);
		
//		String segment_1_a = isSegmentActive(1,iCount++ %2) ? fgColor : bgColor;
		String segment_1_a = isSegmentActive(1,iHour_FirstDigit) ? fgColor : bgColor;
		String segment_1_b = isSegmentActive(2,iHour_FirstDigit) ? fgColor : bgColor;
		String segment_1_c = isSegmentActive(3,iHour_FirstDigit) ? fgColor : bgColor;
		String segment_1_d = isSegmentActive(4,iHour_FirstDigit) ? fgColor : bgColor;
		String segment_1_e = isSegmentActive(5,iHour_FirstDigit) ? fgColor : bgColor;
		String segment_1_f = isSegmentActive(6,iHour_FirstDigit) ? fgColor : bgColor;
		String segment_1_g = isSegmentActive(7,iHour_FirstDigit) ? fgColor : bgColor;
		
		String segment_2_a = isSegmentActive(1,iHour_SecondDigit) ? fgColor : bgColor;
		String segment_2_b = isSegmentActive(2,iHour_SecondDigit) ? fgColor : bgColor;
		String segment_2_c = isSegmentActive(3,iHour_SecondDigit) ? fgColor : bgColor;
		String segment_2_d = isSegmentActive(4,iHour_SecondDigit) ? fgColor : bgColor;
		String segment_2_e = isSegmentActive(5,iHour_SecondDigit) ? fgColor : bgColor;
		String segment_2_f = isSegmentActive(6,iHour_SecondDigit) ? fgColor : bgColor;
		String segment_2_g = isSegmentActive(7,iHour_SecondDigit) ? fgColor : bgColor;
		
		String segment_3_a = isSegmentActive(1,iMin_FirstDigit) ? fgColor : bgColor;
		String segment_3_b = isSegmentActive(2,iMin_FirstDigit) ? fgColor : bgColor;
		String segment_3_c = isSegmentActive(3,iMin_FirstDigit) ? fgColor : bgColor;
		String segment_3_d = isSegmentActive(4,iMin_FirstDigit) ? fgColor : bgColor;
		String segment_3_e = isSegmentActive(5,iMin_FirstDigit) ? fgColor : bgColor;
		String segment_3_f = isSegmentActive(6,iMin_FirstDigit) ? fgColor : bgColor;
		String segment_3_g = isSegmentActive(7,iMin_FirstDigit) ? fgColor : bgColor;
		
		String segment_4_a = isSegmentActive(1,iMin_SecondDigit) ? fgColor : bgColor;
		String segment_4_b = isSegmentActive(2,iMin_SecondDigit) ? fgColor : bgColor;
		String segment_4_c = isSegmentActive(3,iMin_SecondDigit) ? fgColor : bgColor;
		String segment_4_d = isSegmentActive(4,iMin_SecondDigit) ? fgColor : bgColor;
		String segment_4_e = isSegmentActive(5,iMin_SecondDigit) ? fgColor : bgColor;
		String segment_4_f = isSegmentActive(6,iMin_SecondDigit) ? fgColor : bgColor;
		String segment_4_g = isSegmentActive(7,iMin_SecondDigit) ? fgColor : bgColor;
		
//		page += "<table id=\"table\" style=\"width:300px; height:500px; border:5px solid red; border-collapse:collapse;\">\n";
		page += "<table id=\"table\" style=\"width:300px; height:500px; border: none; border-collapse:collapse;\">\n";
//		page += "<table id=\"mytable\" style=\"width:100%; height:100%; border: none; border-collapse:collapse;\">\n";
		page += "<tr>\n";
		page += "<td style=\"width:3%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:14%; height:5%; background-color:"+segment_1_a+";\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:5%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:14%; height:5%; background-color:"+segment_2_a+";\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:4%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:2%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:4%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:14%; height:5%; background-color:"+segment_3_a+";\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:5%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:14%; height:5%; background-color:"+segment_4_a+";\"></td>\n";
		page += "<td style=\"width:5%; height:5%; background-color:white;\"></td>\n";
		page += "</tr>\n";
		page += "<tr>\n";
		page += "<td style=\"width:3%; height:25%; background-color:"+segment_1_b+";\"></td>\n";
		page += "<td style=\"width:14%; height:25%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:25%; background-color:"+segment_1_c+";\"></td>\n";
		page += "<td style=\"width:5%; height:25%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:25%; background-color:"+segment_2_b+";\"></td>\n";
		page += "<td style=\"width:14%; height:25%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:25%; background-color:"+segment_2_c+";\"></td>\n";
		page += "<td style=\"width:4%; height:25%; background-color:white;\"></td>\n";
		page += "<td style=\"width:2%; height:25%; background-color:white;\"></td>\n";
		page += "<td style=\"width:4%; height:25%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:25%; background-color:"+segment_3_b+";\"></td>\n";
		page += "<td style=\"width:14%; height:25%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:25%; background-color:"+segment_3_c+";\"></td>\n";
		page += "<td style=\"width:5%; height:25%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:25%; background-color:"+segment_4_b+";\"></td>\n";
		page += "<td style=\"width:14%; height:25%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:25%; background-color:"+segment_4_c+";\"></td>\n";
		page += "</tr>\n";
		page += "<tr>\n";
		page += "<td style=\"width:3%; height:5%; background-color:"+segment_1_b+";\"></td>\n";
		page += "<td style=\"width:14%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:"+segment_1_c+";\"></td>\n";
		page += "<td style=\"width:5%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:"+segment_2_b+";\"></td>\n";
		page += "<td style=\"width:14%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:"+segment_2_c+";\"></td>\n";
		page += "<td style=\"width:4%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:2%; height:5%; background-color:green;\"></td>\n";
		page += "<td style=\"width:4%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:"+segment_3_b+";\"></td>\n";
		page += "<td style=\"width:14%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:"+segment_3_c+";\"></td>\n";
		page += "<td style=\"width:5%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:"+segment_4_b+";\"></td>\n";
		page += "<td style=\"width:14%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:"+segment_4_c+";\"></td>\n";
		page += "</tr>\n";
		page += "<tr>\n";
		page += "<td style=\"width:3%; height:7%; background-color:"+segment_1_b+";\"></td>\n";
		page += "<td style=\"width:14%; height:7%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:7%; background-color:"+segment_1_c+";\"></td>\n";
		page += "<td style=\"width:5%; height:7%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:7%; background-color:"+segment_2_b+";\"></td>\n";
		page += "<td style=\"width:14%; height:7%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:7%; background-color:"+segment_2_c+";\"></td>\n";
		page += "<td style=\"width:4%; height:7%; background-color:white;\"></td>\n";
		page += "<td style=\"width:2%; height:7%; background-color:white;\"></td>\n";
		page += "<td style=\"width:4%; height:7%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:7%; background-color:"+segment_3_b+";\"></td>\n";
		page += "<td style=\"width:14%; height:7%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:7%; background-color:"+segment_3_c+";\"></td>\n";
		page += "<td style=\"width:5%; height:7%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:7%; background-color:"+segment_4_b+";\"></td>\n";
		page += "<td style=\"width:14%; height:7%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:7%; background-color:"+segment_4_c+";\"></td>\n";
		page += "</tr>\n";
		page += "<tr>\n";
		page += "<td style=\"width:3%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:14%; height:5%; background-color:"+segment_1_d+";\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:5%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:14%; height:5%; background-color:"+segment_2_d+";\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:4%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:2%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:4%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:14%; height:5%; background-color:"+segment_3_d+";\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:5%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:14%; height:5%; background-color:"+segment_4_d+";\"></td>\n";
		page += "<td style=\"width:5%; height:5%; background-color:white;\"></td>\n";
		page += "</tr>\n";
		page += "<tr>\n";
		page += "<td style=\"width:3%; height:7%; background-color:"+segment_1_e+";\"></td>\n";
		page += "<td style=\"width:14%; height:7%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:7%; background-color:"+segment_1_f+";\"></td>\n";
		page += "<td style=\"width:5%; height:7%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:7%; background-color:"+segment_2_e+";\"></td>\n";
		page += "<td style=\"width:14%; height:7%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:7%; background-color:"+segment_2_f+";\"></td>\n";
		page += "<td style=\"width:4%; height:7%; background-color:white;\"></td>\n";
		page += "<td style=\"width:2%; height:7%; background-color:white;\"></td>\n";
		page += "<td style=\"width:4%; height:7%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:7%; background-color:"+segment_3_e+";\"></td>\n";
		page += "<td style=\"width:14%; height:7%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:7%; background-color:"+segment_3_f+";\"></td>\n";
		page += "<td style=\"width:5%; height:7%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:7%; background-color:"+segment_4_e+";\"></td>\n";
		page += "<td style=\"width:14%; height:7%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:7%; background-color:"+segment_4_f+";\"></td>\n";
		page += "</tr>\n";
		page += "<tr>\n";
		page += "<td style=\"width:3%; height:5%; background-color:"+segment_1_e+";\"></td>\n";
		page += "<td style=\"width:14%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:"+segment_1_f+";\"></td>\n";
		page += "<td style=\"width:5%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:"+segment_2_e+";\"></td>\n";
		page += "<td style=\"width:14%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:"+segment_2_f+";\"></td>\n";
		page += "<td style=\"width:4%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:2%; height:5%; background-color:green;\"></td>\n";
		page += "<td style=\"width:4%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:"+segment_3_e+";\"></td>\n";
		page += "<td style=\"width:14%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:"+segment_3_f+";\"></td>\n";
		page += "<td style=\"width:5%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:"+segment_4_e+";\"></td>\n";
		page += "<td style=\"width:14%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:"+segment_4_f+";\"></td>\n";
		page += "</tr>\n";
		page += "<tr>\n";
		page += "<td style=\"width:3%; height:25%; background-color:"+segment_1_e+";\"></td>\n";
		page += "<td style=\"width:14%; height:25%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:25%; background-color:"+segment_1_f+";\"></td>\n";
		page += "<td style=\"width:5%; height:25%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:25%; background-color:"+segment_2_e+";\"></td>\n";
		page += "<td style=\"width:14%; height:25%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:25%; background-color:"+segment_2_f+";\"></td>\n";
		page += "<td style=\"width:4%; height:25%; background-color:white;\"></td>\n";
		page += "<td style=\"width:2%; height:25%; background-color:white;\"></td>\n";
		page += "<td style=\"width:4%; height:25%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:25%; background-color:"+segment_3_e+";\"></td>\n";
		page += "<td style=\"width:14%; height:25%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:25%; background-color:"+segment_3_f+";\"></td>\n";
		page += "<td style=\"width:5%; height:25%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:25%; background-color:"+segment_4_e+";\"></td>\n";
		page += "<td style=\"width:14%; height:25%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:25%; background-color:"+segment_4_f+";\"></td>\n";
		page += "</tr>\n";
		page += "<tr>\n";
		page += "<td style=\"width:3%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:14%; height:5%; background-color:"+segment_1_g+";\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:5%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:14%; height:5%; background-color:"+segment_2_g+";\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:4%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:2%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:4%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:14%; height:5%; background-color:"+segment_3_g+";\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:5%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:3%; height:5%; background-color:white;\"></td>\n";
		page += "<td style=\"width:14%; height:5%; background-color:"+segment_4_g+";\"></td>\n";
		page += "<td style=\"width:5%; height:5%; background-color:white;\"></td>\n";
		page += "</tr>\n";
		page += "</table>\n";
		
		page += "<script language=\"JavaScript\">\n";
		page += "<!--\n";
		page += "var table = document.getElementById(\"table\");";
		page += "table.style.width = (window.innerWidth*0.95)+'px';\n";
		page += "table.style.height = (window.innerHeight*0.95*"+iVerticalSize+"/100)+'px';\n";
		page += "// -->\n";
		page += "</script>\n";
		
		return page;
	}
	
	
    protected static boolean isSegmentActive(int iSegment, int iValue)
    {
        return ( (iSevenSegmentDisplay[iValue] & (1 << (iSegment-1))) != 0 );
    }
    
	
	@Override
	protected boolean useHTML5()
	{
//		return false;
		return true;
	}
	
}
