/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dbfastclockwebserver;

/**
 *
 * @author Daniels laptop
 */
public class HTMLTextClock extends Clock
{
	private static HTMLTextClock htmlTextClock = null;
	
	
	private HTMLTextClock(MySignal mySignal)		// Don't allow anyone except the class itself to create an instance
	{
		super(mySignal);
	};
	
	
	public static HTMLTextClock GetClock(MySignal mySignal)
	{
		if (htmlTextClock == null)
			htmlTextClock = new HTMLTextClock(mySignal);
		
		return htmlTextClock;
	}
	
	
	@Override
	public String getName()
	{
		return "HTMLTextClock";
	}

	@Override
	protected String getClockHTMLPage(int iHour, int iMin, int iSec, double dSpeed, int iVerticalSize)
	{
		String clockStr = String.format("%02d:%02d", iHour, iMin);
		String page = "";
		
		
//		page += "<div id=\"textcontainer\" style=\"width: 100%; height: "+iVerticalSize+"%; border: 0px;\">\n";
		page += "<div id=\"textcontainer\" style=\"width: 100px; height: 100px; border: 0px;\">\n";
//		page += "<div id=\"textcontainer\" style=\"width: 100px; height: 100px; border:5px solid red;\">\n";
		page += "<script language=\"JavaScript\">\n";
		page += "<!--\n";
		page += "var textcontainer = document.getElementById (\"textcontainer\");\n";
		page += "textcontainer.style.width = (window.innerWidth*0.95)+'px';\n";
		page += "textcontainer.style.height = (window.innerHeight*0.95*"+iVerticalSize+"/100)+'px';\n";
		page += "var mittW = window.innerWidth;\n";
		page += "var mittH = window.innerHeight*"+iVerticalSize+"/100;\n";
		page += "var factorW = 2.5;\n";
		page += "var factorH = 1.2;\n";
		page += "var calculatedfontSize;\n";
		page += "if( (mittH/factorH) < (mittW/factorW) ){\n";
		page += "calculatedfontSize=mittH/factorH;\n";
		page += "}\n";
		page += "else{\n";
		page += "calculatedfontSize=mittW/factorW;\n";
		page += "}\n";
		page += "var currentTime=\""+clockStr+"\";\n";
		page += "var theTime = '<div style=\"font-size:'+calculatedfontSize+'px\">'+currentTime+'</div>';\n";
		page += "document.write(theTime);\n";
		page += "// -->\n";
		page += "</script>\n";
		page += "</div>\n";
		
		return page;
	}
	
	
	@Override
	protected boolean useHTML5()
	{
//		return false;
		return true;
	}
	
}
