/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dbfastclockwebserver;

/**
 *
 * @author Daniels laptop
 */
public class HTML_SVG_Clock extends Clock
{
	private static HTML_SVG_Clock html_SVG_Clock = null;
	
	
	private HTML_SVG_Clock(MySignal mySignal)		// Don't allow anyone except the class itself to create an instance
	{
		super(mySignal);
	};
	
	
	public static HTML_SVG_Clock GetClock(MySignal mySignal)
	{
		if (html_SVG_Clock == null)
			html_SVG_Clock = new HTML_SVG_Clock(mySignal);
		
		return html_SVG_Clock;
	}
	
	
	@Override
	public String getName()
	{
		return "HTML_SVG_Clock";
	}
	
	
	@Override
	protected String getClockHTMLPage(int iHour, int iMin, int iSec, double dSpeed, int iVerticalSize)
	{
		String page = "";
		
		return getSVGClock(iHour, iMin, iSec, iVerticalSize);
	}
	
	
	private String getSVGClock(int iHour, int iMin, int iSec, int iVerticalSize)
	{
		String page = "";
		
		page += "<div id=\"textcontainer\" style=\"position: absolute; width: 100%; height: "+iVerticalSize+"%; border: 0px;\">\n";
		page += "</div>";
		
		page += "<div id=\"svg_container\" style=\"width: 100%; height: "+iVerticalSize+"%; border: 0px; overflow:hidden;\">\n";
		
		page += "<svg id=\"picture\" xmlns=\"http://www.w3.org/2000/svg\"\n";
		
		page += "     xmlns:xlink=\"http://www.w3.org/1999/xlink\"\n";
		page += "     viewBox=\"-1024 -1024 2048 2048\" width=\"600\" height=\"600\">\n";
		page += "  <title>Swiss Railway Clock</title>\n";
		page += "  <style type=\"text/css\">\n";
		page += "    .bg {stroke: none; fill: white;}\n";
		page += "    .fc {stroke: none; fill: black;}\n";
		page += "    .h1 {stroke: none; fill: black;}\n";
		page += "    .h2 {stroke: none; fill: #aa0000;}\n";
		page += "  </style>\n";
		page += "  <defs>\n";
		page += "    <path id=\"mark1\" d=\"M -20,-1000 l 40,0 0,100 -40,0 z\" />\n";
		page += "    <path id=\"mark2\" d=\"M -40,-1000 l 80,0 0,240 -80,0 z\" />\n";
		page += "    <path id=\"mark3\" d=\"M -40,-1000 l 80,0 0,300 -80,0 z\" />\n";
		page += "    <path id=\"handh\" d=\"M -50,-600  l 50,-50 50,50 0,800  -100,0 z\" />\n";
		page += "    <path id=\"handm\" d=\"M -40,-900  l 40,-40 40,40 0,1180 -80,0  z\" />\n";
		page += "    <g id=\"face1\">\n";
		page += "      <use xlink:href=\"#mark1\" transform=\"rotate(06)\" />\n";
		page += "      <use xlink:href=\"#mark1\" transform=\"rotate(12)\" />\n";
		page += "      <use xlink:href=\"#mark1\" transform=\"rotate(18)\" />\n";
		page += "      <use xlink:href=\"#mark1\" transform=\"rotate(24)\" />\n";
		page += "    </g>\n";
		page += "    <g id=\"face2\">\n";
		page += "      <use xlink:href=\"#face1\" />\n";
		page += "      <use xlink:href=\"#face1\" transform=\"rotate(30)\" />\n";
		page += "      <use xlink:href=\"#face1\" transform=\"rotate(60)\" />\n";
		page += "      <use xlink:href=\"#mark3\" />\n";
		page += "      <use xlink:href=\"#mark2\" transform=\"rotate(30)\" />\n";
		page += "      <use xlink:href=\"#mark2\" transform=\"rotate(60)\" />\n";
		page += "    </g>\n";
		page += "    <g id=\"face\">\n";
		page += "      <use xlink:href=\"#face2\" />\n";
		page += "      <use xlink:href=\"#face2\" transform=\"rotate(90)\"  />\n";
		page += "      <use xlink:href=\"#face2\" transform=\"rotate(180)\" />\n";
		page += "      <use xlink:href=\"#face2\" transform=\"rotate(270)\" />\n";
		page += "    </g>\n";
		page += "  </defs>\n";
		page += "  <circle class=\"bg\" r=\"1024\" />\n";
		page += "  <use xlink:href=\"#face\"  class=\"fc\" />\n";
		page += "  <use xlink:href=\"#handh\" class=\"h1\" transform=\"rotate("+(iHour*30+iMin/2)+")\" />\n";
		page += "  <use xlink:href=\"#handm\" class=\"h1\" transform=\"rotate("+(iMin*6)+")\" />\n";
		
		page += "</svg>\n";
		
		page += "</div>\n";
		
		page += "<script language=\"JavaScript\">\n";
		page += "<!--\n";
		
		page += "var textcontainer = document.getElementById (\"textcontainer\");\n";
		page += "var svgcontainer = document.getElementById (\"svg_container\");\n";
		
		page += "var obj = document.getElementById(\"picture\"); // reference to the object tag\n";
		page += "var svgdoc = obj.contentDocument; // reference to the SVG document\n";
		page += "var svgelem = obj.documentElement; // reference to the SVG element\n";
		
		page += "var width = obj.getAttribute(\"width\");\n";
		page += "var height = obj.getAttribute(\"height\");\n";
		
		page += "var mittW = textcontainer.offsetWidth;\n";
		page += "var mittH = textcontainer.offsetHeight;\n";
		page += "var minValue = Math.min(mittW,mittH);\n";
		page += "obj.setAttribute(\"width\",minValue*0.95);\n";
		page += "obj.setAttribute(\"height\",minValue*0.95);\n";
		page += "textcontainer.style.display = \"none\"\n";
		
		page += "// -->\n";
		page += "</script>\n";
		
		return page;
	}
	
	
	@Override
	protected boolean useHTML5()
	{
		return true;
	}
}
