/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dbfastclockwebserver;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.BindException;
import java.net.ServerSocket;
import java.net.Socket;



/**
 *
 * @author Daniels laptop
 */
public class HTTPServerComm implements Runnable
{

	DBFastClockWebServer dbFastClockWebServer;
	MySignal mySignal;

	public HTTPServerComm(DBFastClockWebServer dbFastClockWebServer, MySignal mySignal)
	{
		this.dbFastClockWebServer = dbFastClockWebServer;
		this.mySignal = mySignal;
	}

	public void run()
	{
//		dbFastClockWebServer.addInfoMessageLn("TCPServerComm.run()");
		
		int iHTTPPort = mySignal.getServerHTTPport();

		while (true)
		{
			if (iHTTPPort != -1)
			{
				try
				{
					dbFastClockWebServer.addInfoMessageLn("iHTTPPort: "+iHTTPPort);
					
					ServerSocket listener = new ServerSocket(iHTTPPort);

					Socket server;

//					dbFastClockWebServer.addInfoMessageLn("Start listening\n");
					
					while (iHTTPPort == mySignal.getServerHTTPport())
					{
						// Get socket
						server = listener.accept();
						
						HTTPServerRequest httpServerRequest = new HTTPServerRequest(dbFastClockWebServer, mySignal, server);
						
						Thread thread = new Thread(httpServerRequest);
						thread.start();
						
					}
					
					// Close server socket if the tcp port changes
					listener.close();
				}
				catch (BindException ex)
				{
					dbFastClockWebServer.addInfoMessageLn("Error: TCP-porten används redan");
				}
				catch (IllegalArgumentException ex)
				{
					dbFastClockWebServer.addInfoMessageLn("Error: "+ex.getMessage());
					dbFastClockWebServer.addInfoMessageLn(StringUtils.getStackTrace(ex));
				}
				catch (IOException ex)
				{
					dbFastClockWebServer.addInfoMessageLn("IOException on socket listen: " + ex);
					dbFastClockWebServer.addInfoMessageLn(StringUtils.getStackTrace(ex));
//					ioe.printStackTrace();
				}
			}
			else
			{
				try
				{
					Thread.sleep(100);
				}
				catch (InterruptedException ex)
				{
					// Don't handle this exception
//						Logger.getLogger(TCPCommClockServer.class.getName()).log(Level.SEVERE, null, ex);
				}
			}
		}
	}
}

