/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dbfastclockwebserver;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.Socket;
import java.net.SocketException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Daniels laptop
 */
public class HTTPServerRequest implements Runnable
{
	DBFastClockWebServer dbFastClockWebServer;
	MySignal mySignal;
	Socket socket;
	
	
	public HTTPServerRequest(DBFastClockWebServer dbFastClockWebServer, MySignal mySignal, Socket socket)
	{
		this.dbFastClockWebServer = dbFastClockWebServer;
		this.socket = socket;
		this.mySignal = mySignal;
	}
	
	
	@Override
	public void run()
	{
		BufferedReader input = null;
		try
		{
			input = new BufferedReader(new InputStreamReader(socket.getInputStream()));
			if (input != null)
			{
				String requestStr = input.readLine();
				if (requestStr != null)
				{
					String path = "";
					
					requestStr.toUpperCase();
//					System.out.println(requestStr);
					
					if (requestStr.startsWith("GET"))
						path = requestStr.substring( "GET ".length() );
					else if (requestStr.startsWith("HEAD "))
						path = requestStr.substring( "HEAD ".length() );
					
					if (! path.isEmpty())
						path = path.substring(1, path.indexOf(' '));
					
//					System.out.println("Path: ;"+path+";  "+path.indexOf(' ')+", "+path.indexOf('T'));
					
					PrintWriter out = new PrintWriter(new OutputStreamWriter(socket.getOutputStream(), "UTF-8"));
					
					Clock selectedClock = mySignal.getClock();
					
					if (! path.isEmpty())
					{
						for (Clock clock : mySignal.getClockList())
						{
							if (clock.getName().equals(path))
							{
								selectedClock = clock;
								break;
							}
						}
					}
					
					String sTextMsg = selectedClock.getHTMLPage(mySignal.getClockHour(), mySignal.getClockMin(), mySignal.getClockSec(), mySignal.getClockSpeed(), mySignal.getTextMessage());
					String sTextMessage = mySignal.getText();
					sTextMessage = sTextMessage.replaceAll("\n", "\\\\n");
					
					out.print(sTextMsg);
					out.close();
				}
				else
				{
					dbFastClockWebServer.addInfoMessageLn("\n'tmp' is null pointer in HTTPServerRequest\n");
					dbFastClockWebServer.addInfoMessageLn("Client IP-address: " + socket.getInetAddress().getHostAddress());
				}
			}
			else
			{
				dbFastClockWebServer.addInfoMessageLn("\n'input' is null pointer in HTTPServerRequest\n");
				dbFastClockWebServer.addInfoMessageLn("Client IP-address: "+socket.getInetAddress().getHostAddress());
			}
			// Immediately close this socket
			socket.close();
		}
		catch (IOException ex)
		{
			if (ex.getCause() instanceof SocketException)
			{
				dbFastClockWebServer.addInfoMessageLn("\nSocketException on socket listen: " + ex);
				dbFastClockWebServer.addInfoMessageLn("Client IP-address: "+socket.getInetAddress().getHostAddress());
			}
			else
			{
				dbFastClockWebServer.addInfoMessageLn("\nIOException on socket listen: " + ex);
				dbFastClockWebServer.addInfoMessageLn("+ Client IP-address: "+socket.getInetAddress().getHostAddress());
				if (ex.getCause().getClass() != null)
					dbFastClockWebServer.addInfoMessageLn("Class: " + ex.getClass().getName() + " - " + ex.getCause().getClass().getName());
				dbFastClockWebServer.addInfoMessageLn(StringUtils.getStackTrace(ex));
			}
		}
		finally
		{
			try
			{
				input.close();
			}
			catch (IOException ex)
			{
				Logger.getLogger(HTTPServerRequest.class.getName()).log(Level.SEVERE, null, ex);
			}
		}
	}
}
