/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dbfastclockwebserver;

import java.io.BufferedWriter;
import java.util.List;

/**
 *
 * @author Daniels laptop
 */
public class MySignal
{
	public static final int CLOCK_TYPE__FAST_CLOCK = 0;
	public static final int CLOCK_TYPE__REAL_CLOCK = 1;
	
	public static final int WEEKDAY_NONE = 0;
	public static final int WEEKDAY_MONDAY = 1;
	public static final int WEEKDAY_TUESDAY = 2;
	public static final int WEEKDAY_WEDNESDAY = 3;
	public static final int WEEKDAY_THURSDAY = 4;
	public static final int WEEKDAY_FRIDAY = 5;
	public static final int WEEKDAY_SATURDAY = 6;
	public static final int WEEKDAY_SUNDAY = 7;
	
	protected DBFastClockWebServer dbFastClockWebServer;
	public BufferedWriter debug;
	
    private String sClientIPaddress = "127.0.0.1";
    private int iClientTCPport = -1;    // -1 is invalid TCP port number and the thread will not try connect in this case
    private int iServerHTTPport = -1;    // -1 is invalid TCP port number and the thread will not try open port in this case
	private int iClockType = 1;		// 0 = Snabbklocka, 1 = Datortid
	private boolean bClockIsActive = false;		// 1 = Klockan går, 0 = Klockan är pausad
    private int iClockDay = -1;
    private int iClockHour = -1;
    private int iClockMin = -1;
	private int iClockSec = -1;
	private double dClockSpeed = -1;
	private boolean bTextMessageVisible;
	private String sTextMessage;
	private String sCurrentTextMessageLine;
	private int iCurrentTextMessageRow;
	private List<Clock> clockList;
	private Clock clock;
	private Clock menuClock = null;
	
	
	public MySignal(List<Clock> clockList)
	{
		this.clockList = clockList;
	}
	
	
    public synchronized void setIPaddressAndPort(String iTheClientIPaddress, int iTheClientTCPport, int iTheServerHTTPport)
	{
        sClientIPaddress = iTheClientIPaddress;
        iClientTCPport = iTheClientTCPport;
		iServerHTTPport = iTheServerHTTPport;
    }

    public synchronized String getClientIPaddress()
	{
        return sClientIPaddress;
    }
    
    public synchronized int getClientTCPport()
	{
        return iClientTCPport;
    }
    
    public synchronized int getServerHTTPport()
	{
        return iServerHTTPport;
    }
    
    public synchronized void setClockTime(	int iType,
											boolean bIsActive,
											int iDay,
											int iHour,
											int iMin,
											int iSec,
											double dSpeed)
	{
        iClockType = iType;
        bClockIsActive = bIsActive;
        iClockDay = iDay;
        iClockHour = iHour;
        iClockMin = iMin;
        iClockSec = iSec;
        dClockSpeed = dSpeed;
    }

	
	void SetText(boolean bTextMessageVisible, String sTextMessage)
	{
		boolean bNewText = bTextMessageVisible &&  ( ! sTextMessage.equals(this.sTextMessage) );
		
		this.bTextMessageVisible = bTextMessageVisible;
		this.sTextMessage = sTextMessage;
		
		if (bNewText)
		{
			if (! sTextMessage.isEmpty())
			{
				iCurrentTextMessageRow = 0;
				String[] textArray = sTextMessage.split("\n");
				sCurrentTextMessageLine = textArray[iCurrentTextMessageRow];
			}
		}
	}
	
	
    public synchronized int getClockType()
	{
        return iClockType;
    }
    
    public synchronized boolean getClockIsActive()
	{
        return bClockIsActive;
    }
    
    public synchronized int getClockDay()
	{
        return iClockDay;
    }
    
    public synchronized int getClockHour()
	{
        return iClockHour;
    }
    
    public synchronized int getClockMin()
	{
        return iClockMin;
    }
    
    public synchronized int getClockSec()
	{
        return iClockSec;
    }
    
    public synchronized double getClockSpeed()
	{
        return dClockSpeed;
    }
    
    public synchronized boolean getTextVisible()
	{
        return bTextMessageVisible;
    }
    
	
    public synchronized String getText()
	{
        return (bTextMessageVisible ? sTextMessage : "");
    }
    
	
    public synchronized String getTextMessage()
	{
        return (bTextMessageVisible ? sCurrentTextMessageLine : "");
    }
    
	
	public static String getYesNoString(boolean bValue)
	{
		return (bValue ? "yes" : "no");
	}
	
	
	public static String getClockTypeString(int iClockType)
	{
		switch (iClockType)
		{
			case CLOCK_TYPE__REAL_CLOCK: return "realclock";
			case CLOCK_TYPE__FAST_CLOCK: return "fastclock";
			default: return "error_wrong_value";
		}
	}
	
	
	public static String getDayString(int iDay)
	{
		switch (iDay)
		{
			case WEEKDAY_NONE: return "none";
			case WEEKDAY_MONDAY: return "monday";
			case WEEKDAY_TUESDAY: return "tuesday";
			case WEEKDAY_WEDNESDAY: return "wednesday";
			case WEEKDAY_THURSDAY: return "thursday";
			case WEEKDAY_FRIDAY: return "friday";
			case WEEKDAY_SATURDAY: return "saturday";
			case WEEKDAY_SUNDAY: return "sunday";
			default: return "error_wrong_value";
		}
	}
	
	
	public synchronized void setClock(Clock clock)
	{
		this.clock = clock;
	}
	
	
	public synchronized Clock getClock()
	{
		return clock;
	}
	
	
	public synchronized void setMenuClock(Clock menuClock)
	{
		this.menuClock = menuClock;
	}
	
	
	public synchronized Clock getMenuClock()
	{
		return menuClock;
	}
	
	
	public synchronized List<Clock> getClockList()
	{
		return clockList;
	}
	
	
	public synchronized void shiftText()
	{
		if (bTextMessageVisible)
		{
			if (sCurrentTextMessageLine.length() > 0)
			{
				sCurrentTextMessageLine = sCurrentTextMessageLine.substring(1);
			}
			else
			{
				iCurrentTextMessageRow++;

				String[] textArray = sTextMessage.split("\n");
				if (iCurrentTextMessageRow >= textArray.length)
				{
					iCurrentTextMessageRow = 0;
				}

				sCurrentTextMessageLine = "         " + textArray[iCurrentTextMessageRow];
			}
			
//			System.out.println("MySignal Text message :"+bTextMessageVisible+", "+sCurrentTextMessageLine);
		}
	}
	
	
	public String getLocalizedName(String key_prefix, String key)
	{
		return dbFastClockWebServer.getLocalizedName(key_prefix, key, null);
	}
	
	
	public String getLocalizedName(String key_prefix, String key, String parameter)
	{
		return dbFastClockWebServer.getLocalizedName(key_prefix, key, parameter);
	}
	
}
